diff -u cvs/hq/wine/windows/x11drv/keyboard.c wine/windows/x11drv/keyboard.c
--- cvs/hq/wine/windows/x11drv/keyboard.c	Thu Sep 20 13:19:40 2001
+++ wine/windows/x11drv/keyboard.c	Tue Sep 25 18:57:55 2001
@@ -618,7 +618,7 @@
     return keyc2vkey[e->keycode];
 }
 
-static BOOL NumState=FALSE, CapsState=FALSE, AltGrState=FALSE;
+static BOOL NumState=FALSE, CapsState=FALSE;
 
 /**********************************************************************
  *		KEYBOARD_GenerateMsg
@@ -757,27 +757,7 @@
        predefined group index and find it dynamically
 
        Ref: X Keyboard Extension: Library specification (section 14.1.1 and 17.1.1) */
-    if ( AltGrState && (event->state & 0x6000) )
-        AltGrMask = event->state & 0x6000;
-
-    if (keysym == XK_Mode_switch)
-	{
-	TRACE_(key)("Alt Gr key event received\n");
-	event->keycode = kcControl; /* Simulate Control */
-	X11DRV_KEYBOARD_HandleEvent( event, x, y );
-
-	event->keycode = kcAlt; /* Simulate Alt */
-	force_extended = TRUE;
-	X11DRV_KEYBOARD_HandleEvent( event, x, y );
-	force_extended = FALSE;
-    
-    /* Here we save the pressed/released state of the AltGr key, to be able to 
-       identify the group index associated with AltGr on the next key pressed *
-       see comment above. */
-    AltGrState = (event->type == KeyPress) ? TRUE : FALSE;
-    
-	return;
-	}
+    AltGrMask = event->state & 0x2000;
 
     Str[ascii_chars] = '\0';
     if (TRACE_ON(key)){
@@ -1527,14 +1507,13 @@
     if (lpKeyState[VK_CAPITAL] & 0x01)
 	e.state |= LockMask;
     if (lpKeyState[VK_CONTROL] & 0x80)
-    {
-	if (lpKeyState[VK_MENU] & 0x80)
-	    e.state |= AltGrMask;
-	else
-	    e.state |= ControlMask;
-    }
+	e.state |= ControlMask;
     if (lpKeyState[VK_NUMLOCK] & 0x01)
 	e.state |= NumLockMask;
+
+    /* Restore saved AltGr state */
+    e.state |= AltGrMask;
+
     TRACE_(key)("(%04X, %04X) : faked state = %X\n",
 		virtKey, scanCode, e.state);
     /* We exit on the first keycode found, to speed up the thing. */
